import * as i0 from '@angular/core';
import { Injectable, InjectionToken, Component, Input, Inject, Directive, NgModule } from '@angular/core';
import * as i2 from '@angular/forms';
import { FormControl, FormGroup, ReactiveFormsModule, FormsModule } from '@angular/forms';
import { Subject } from 'rxjs';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { tap } from 'rxjs/operators';

class FormService {
    constructor() {
        this.dynamicForm = null;
        this.dynamicFormSubject = new Subject();
    }
    setDynamicForm(_dynamicForm) {
        this.dynamicForm = _dynamicForm;
        this.dynamicFormSubject.next();
    }
    get DynamicForm() {
        return this.dynamicForm;
    }
    get onDynamicForm() {
        return this.dynamicFormSubject.asObservable();
    }
}
FormService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: FormService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
FormService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: FormService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: FormService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

var ControlType;
(function (ControlType) {
    // Input element
    ControlType["Input"] = "input";
    ControlType["Checkbox"] = "checkbox";
    ControlType["Radio"] = "radio";
    ControlType["Text"] = "text";
    ControlType["Time"] = "time";
    ControlType["Date"] = "date";
    ControlType["Password"] = "password";
    // Other elements
    ControlType["Select"] = "select";
    ControlType["Toggle"] = "toggle";
    ControlType["Textarea"] = "textarea";
    // Form specific types
    ControlType["SaveButton"] = "save-button";
    ControlType["CloseButton"] = "close-button";
    ControlType["ResetButton"] = "reset-button";
})(ControlType || (ControlType = {}));
// TODO: Add radio group
// TODO: Add slider
// TODO: Add numeric

/**
 * This is not a real service, but it looks like it from the outside.
 * It's just an InjectionTToken used to import the config object, provided from the outside
 */
const ConfigService = new InjectionToken('NgxFormulusConfig');

class BaseControlComponent {
    constructor() {
        this.dynamicControl = {
            formControl: new FormControl(),
            formControlName: '',
            fullWidth: false,
            hidden: false,
            disabled: false,
        };
    }
    ngOnInit() { }
}
BaseControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: BaseControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BaseControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: BaseControlComponent, selector: "ngx-base-control", inputs: { dynamicControl: "dynamicControl" }, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: BaseControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-base-control',
                    template: '',
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { dynamicControl: [{
                type: Input
            }] } });

class InputControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
InputControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: InputControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
InputControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: InputControlComponent, selector: "ngx-input-control", usesInheritance: true, ngImport: i0, template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [type]=\"dynamicControl.type || 'text'\" [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\"\n    [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: InputControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-input-control', template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [type]=\"dynamicControl.type || 'text'\" [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\"\n    [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"] }]
        }], ctorParameters: function () { return []; } });

class RadioControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
    onChange($event) {
        if ($event) {
            const target = $event.target;
            this.dynamicControl.formControl.setValue(target.checked);
        }
    }
}
RadioControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: RadioControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
RadioControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: RadioControlComponent, selector: "ngx-radio-control", usesInheritance: true, ngImport: i0, template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input (change)=\"onChange($event)\" [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\"\n    [id]=\"dynamicControl.formControlName\" [type]=\"dynamicControl.type || 'radio'\"\n    [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\"\n    [attr.checked]=\"dynamicControl.formControl.value ? '' : null\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: RadioControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-radio-control', template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input (change)=\"onChange($event)\" [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\"\n    [id]=\"dynamicControl.formControlName\" [type]=\"dynamicControl.type || 'radio'\"\n    [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\"\n    [attr.checked]=\"dynamicControl.formControl.value ? '' : null\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"] }]
        }], ctorParameters: function () { return []; } });

class SelectControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
SelectControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: SelectControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SelectControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: SelectControlComponent, selector: "ngx-select-control", usesInheritance: true, ngImport: i0, template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <select [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n    <option *ngFor=\"let option of dynamicControl.data\" [value]=\"option.value\">\n      {{ option.label }}\n    </option>\n  </select>\n</div>\n", styles: [".fullWidth{width:100%}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { type: i2.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: SelectControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-select-control', template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <select [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n    <option *ngFor=\"let option of dynamicControl.data\" [value]=\"option.value\">\n      {{ option.label }}\n    </option>\n  </select>\n</div>\n", styles: [".fullWidth{width:100%}\n"] }]
        }], ctorParameters: function () { return []; } });

class CheckboxControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
    onChange($event) {
        if ($event) {
            const target = $event.target;
            this.dynamicControl.formControl.setValue(target.checked);
        }
    }
}
CheckboxControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: CheckboxControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CheckboxControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: CheckboxControlComponent, selector: "ngx-checkbox-control", usesInheritance: true, ngImport: i0, template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input (change)=\"onChange($event)\" [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\"\n    [id]=\"dynamicControl.formControlName\" [type]=\"dynamicControl.type || 'checkbox'\"\n    [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\"\n    [attr.checked]=\"dynamicControl.formControl.value ? '' : null\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: CheckboxControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-checkbox-control', template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input (change)=\"onChange($event)\" [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\"\n    [id]=\"dynamicControl.formControlName\" [type]=\"dynamicControl.type || 'checkbox'\"\n    [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\"\n    [attr.checked]=\"dynamicControl.formControl.value ? '' : null\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"] }]
        }], ctorParameters: function () { return []; } });

class SaveButtonComponent {
    constructor() { }
    ngOnInit() { }
}
SaveButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: SaveButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SaveButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: SaveButtonComponent, selector: "ngx-save-button", ngImport: i0, template: "<button>Save</button>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: SaveButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-save-button', template: "<button>Save</button>\n", styles: [""] }]
        }], ctorParameters: function () { return []; } });

class CloseButtonComponent {
    constructor() { }
    ngOnInit() { }
}
CloseButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: CloseButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CloseButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: CloseButtonComponent, selector: "ngx-close-button", ngImport: i0, template: "<button>Close</button>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: CloseButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-close-button', template: "<button>Close</button>\n", styles: [""] }]
        }], ctorParameters: function () { return []; } });

class ResetButtonComponent {
    constructor() { }
    ngOnInit() { }
}
ResetButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: ResetButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ResetButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: ResetButtonComponent, selector: "ngx-reset-button", ngImport: i0, template: "<button>Reset</button>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: ResetButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-reset-button', template: "<button>Reset</button>\n", styles: [""] }]
        }], ctorParameters: function () { return []; } });

class ToggleControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
ToggleControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: ToggleControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ToggleControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: ToggleControlComponent, selector: "ngx-toggle-control", usesInheritance: true, ngImport: i0, template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [type]=\"dynamicControl.type || 'toggle'\" [formControl]=\"dynamicControl.formControl\"\n    *ngIf=\"dynamicControl.formControl\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: ToggleControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-toggle-control', template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [type]=\"dynamicControl.type || 'toggle'\" [formControl]=\"dynamicControl.formControl\"\n    *ngIf=\"dynamicControl.formControl\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"] }]
        }], ctorParameters: function () { return []; } });

class TextareaControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
TextareaControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: TextareaControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TextareaControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: TextareaControlComponent, selector: "ngx-textarea-control", usesInheritance: true, ngImport: i0, template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <textarea [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n  </textarea>\n</div>\n", styles: [".fullWidth{width:100%}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: TextareaControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-textarea-control', template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label class=\"mr-2\" [for]=\"dynamicControl.formControlName\"\n    *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <textarea [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\" [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n  </textarea>\n</div>\n", styles: [".fullWidth{width:100%}\n"] }]
        }], ctorParameters: function () { return []; } });

class TemplateService {
    constructor(_config) {
        this._config = _config;
        this.templates = {};
        this.config = _config;
        this.setDefaultTemplates();
        this.mapTemplates();
    }
    /**
     * Get component by ControlType
     * @param controlType
     * @returns Component
     */
    getComponent(controlType) {
        return this.getComponentByType(controlType);
    }
    /**
     * Inject component for specific template
     * @param template
     * @param controlType
     */
    setTemplate(template, controlType) {
        this.templates[controlType] = template;
    }
    /**
     * Get all registered templates
     */
    get RegisteredTemplates() {
        return this.templates;
    }
    // TODO: Add template functionality for every component
    /**
     * Set all default templates for each component
     */
    setDefaultTemplates() {
        // Input
        this.templates[ControlType.Input] = InputControlComponent;
        // Checkbox
        this.templates[ControlType.Checkbox] =
            CheckboxControlComponent;
        // Radio
        this.templates[ControlType.Radio] = RadioControlComponent;
        // Select
        this.templates[ControlType.Select] = SelectControlComponent;
        // Text
        this.templates[ControlType.Text] = InputControlComponent;
        // Password
        this.templates[ControlType.Password] = InputControlComponent;
        // Time
        this.templates[ControlType.Time] = InputControlComponent;
        // Date
        this.templates[ControlType.Date] = InputControlComponent;
        // Toggle
        this.templates[ControlType.Toggle] = ToggleControlComponent;
        // Textarea
        this.templates[ControlType.Textarea] =
            TextareaControlComponent;
        // TODO: Add radio group
        // Form specific components
        this.templates[ControlType.SaveButton] = SaveButtonComponent;
        this.templates[ControlType.CloseButton] = CloseButtonComponent;
        this.templates[ControlType.ResetButton] = ResetButtonComponent;
    }
    /**
     * Map all templates
     */
    mapTemplates() {
        if (this.config && this.config.templates) {
            for (const templateName in this.config.templates) {
                const template = this.config.templates[templateName];
                this.templates[templateName] = template;
            }
        }
    }
    /**
     * Get component by ControlType
     * @param type
     * @returns Component
     */
    getComponentByType(type) {
        return this.templates[type];
    }
}
TemplateService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: TemplateService, deps: [{ token: ConfigService }], target: i0.ɵɵFactoryTarget.Injectable });
TemplateService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: TemplateService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: TemplateService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [ConfigService]
                }] }]; } });

class DynamicControlDirective {
    constructor(resolver, container, renderer, templateService) {
        this.resolver = resolver;
        this.container = container;
        this.renderer = renderer;
        this.templateService = templateService;
        this.componentRef = null;
        this.dynamicControl = null;
    }
    ngOnInit() {
        if (this.dynamicControl && this.dynamicControl.type) {
            const component = this.templateService.getComponent(this.dynamicControl.type);
            if (component) {
                const factory = this.resolver.resolveComponentFactory(component);
                this.componentRef = this.container.createComponent(factory);
                this.componentRef.instance.dynamicControl = this.dynamicControl;
            }
        }
    }
}
DynamicControlDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: DynamicControlDirective, deps: [{ token: i0.ComponentFactoryResolver }, { token: i0.ViewContainerRef }, { token: i0.Renderer2 }, { token: TemplateService }], target: i0.ɵɵFactoryTarget.Directive });
DynamicControlDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.0", type: DynamicControlDirective, selector: "[ngxDynamicControl]", inputs: { dynamicControl: "dynamicControl" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: DynamicControlDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngxDynamicControl]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ComponentFactoryResolver }, { type: i0.ViewContainerRef }, { type: i0.Renderer2 }, { type: TemplateService }]; }, propDecorators: { dynamicControl: [{
                type: Input
            }] } });

class FormControlDirective {
    constructor(resolver, container, templateService) {
        this.resolver = resolver;
        this.container = container;
        this.templateService = templateService;
        this.componentRef = null;
    }
    ngOnInit() {
        if (this.formControlType) {
            let component;
            switch (this.formControlType) {
                case ControlType.SaveButton:
                    component = this.templateService.getComponent(ControlType.SaveButton);
                    break;
                case ControlType.CloseButton:
                    component = this.templateService.getComponent(ControlType.CloseButton);
                    break;
                case ControlType.ResetButton:
                    component = this.templateService.getComponent(ControlType.ResetButton);
                    break;
                default:
                    component = Component;
                    break;
            }
            if (component) {
                const factory = this.resolver.resolveComponentFactory(component);
                this.componentRef = this.container.createComponent(factory);
            }
        }
    }
}
FormControlDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: FormControlDirective, deps: [{ token: i0.ComponentFactoryResolver }, { token: i0.ViewContainerRef }, { token: TemplateService }], target: i0.ɵɵFactoryTarget.Directive });
FormControlDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.0", type: FormControlDirective, selector: "[ngxFormControl]", inputs: { formControlType: "formControlType" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: FormControlDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngxFormControl]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ComponentFactoryResolver }, { type: i0.ViewContainerRef }, { type: TemplateService }]; }, propDecorators: { formControlType: [{
                type: Input
            }] } });

class DynamicFormComponent {
    constructor(formService) {
        this.formService = formService;
        this.data = null;
        this.formGroup = new FormGroup({});
        this.controls = [];
        this.actions = {};
    }
    ngOnInit() {
        if (this.data) {
            this.formService.setDynamicForm(this.data);
            this.formGroup = this.data.FormGroup;
            this.controls = this.data.Controls;
            this.actions = this.data.Actions;
            this.data.onReload.subscribe(() => {
                if (this.data) {
                    this.formGroup = this.data.FormGroup;
                    this.controls = this.data.Controls;
                    this.actions = this.data.Actions;
                }
            });
        }
    }
}
DynamicFormComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: DynamicFormComponent, deps: [{ token: FormService }], target: i0.ɵɵFactoryTarget.Component });
DynamicFormComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.0", type: DynamicFormComponent, selector: "ngx-dynamic-form", inputs: { data: "data" }, ngImport: i0, template: "<ng-container *ngIf=\"data\" class=\"h-100 w-100\">\n  <form class=\"w-100 h-100\" [formGroup]=\"formGroup\" *ngIf=\"data && formGroup && controls && controls.length > 0\">\n\n    <div class=\"d-flex flex-row flex-wrap\">\n      <ng-container *ngFor=\"let control of controls\">\n        <div class=\"d-flex mr-2 mb-2\" *ngIf=\"control && !control.hidden && !control.fullWidth\">\n          <ng-container ngxDynamicControl [dynamicControl]=\"control\"></ng-container>\n        </div>\n        <!-- Full width control -->\n        <div class=\"d-inline-block w-100 mr-2 mb-2\" *ngIf=\"control && !control.hidden && control.fullWidth\">\n          <ng-container ngxDynamicControl [dynamicControl]=\"control\"></ng-container>\n        </div>\n      </ng-container>\n    </div>\n\n    <div class=\"d-flex flex-row\" *ngIf=\"actions\">\n      <div class=\"d-flex\" (click)=\"data.save()\">\n        <ng-container *ngIf=\"actions?.save\" ngxFormControl [formControlType]=\"'save-button'\">\n        </ng-container>\n      </div>\n\n      <div class=\"d-flex ml-2\" (click)=\"data.close()\">\n        <ng-container *ngIf=\"actions?.close\" ngxFormControl [formControlType]=\"'close-button'\">\n        </ng-container>\n      </div>\n\n      <div class=\"d-flex ml-2\" (click)=\"data.reset()\">\n        <ng-container *ngIf=\"actions?.reset\" ngxFormControl [formControlType]=\"'reset-button'\">\n        </ng-container>\n      </div>\n    </div>\n  </form>\n</ng-container>\n", styles: [""], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: DynamicControlDirective, selector: "[ngxDynamicControl]", inputs: ["dynamicControl"] }, { type: FormControlDirective, selector: "[ngxFormControl]", inputs: ["formControlType"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: DynamicFormComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-dynamic-form', template: "<ng-container *ngIf=\"data\" class=\"h-100 w-100\">\n  <form class=\"w-100 h-100\" [formGroup]=\"formGroup\" *ngIf=\"data && formGroup && controls && controls.length > 0\">\n\n    <div class=\"d-flex flex-row flex-wrap\">\n      <ng-container *ngFor=\"let control of controls\">\n        <div class=\"d-flex mr-2 mb-2\" *ngIf=\"control && !control.hidden && !control.fullWidth\">\n          <ng-container ngxDynamicControl [dynamicControl]=\"control\"></ng-container>\n        </div>\n        <!-- Full width control -->\n        <div class=\"d-inline-block w-100 mr-2 mb-2\" *ngIf=\"control && !control.hidden && control.fullWidth\">\n          <ng-container ngxDynamicControl [dynamicControl]=\"control\"></ng-container>\n        </div>\n      </ng-container>\n    </div>\n\n    <div class=\"d-flex flex-row\" *ngIf=\"actions\">\n      <div class=\"d-flex\" (click)=\"data.save()\">\n        <ng-container *ngIf=\"actions?.save\" ngxFormControl [formControlType]=\"'save-button'\">\n        </ng-container>\n      </div>\n\n      <div class=\"d-flex ml-2\" (click)=\"data.close()\">\n        <ng-container *ngIf=\"actions?.close\" ngxFormControl [formControlType]=\"'close-button'\">\n        </ng-container>\n      </div>\n\n      <div class=\"d-flex ml-2\" (click)=\"data.reset()\">\n        <ng-container *ngIf=\"actions?.reset\" ngxFormControl [formControlType]=\"'reset-button'\">\n        </ng-container>\n      </div>\n    </div>\n  </form>\n</ng-container>\n", styles: [""] }]
        }], ctorParameters: function () { return [{ type: FormService }]; }, propDecorators: { data: [{
                type: Input
            }] } });

class NgxFormulusModule {
    static forRoot(config) {
        return {
            ngModule: NgxFormulusModule,
            providers: [
                {
                    provide: ConfigService,
                    useValue: config,
                },
            ],
        };
    }
}
NgxFormulusModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: NgxFormulusModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxFormulusModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: NgxFormulusModule, declarations: [DynamicFormComponent,
        BaseControlComponent,
        DynamicControlDirective,
        FormControlDirective,
        InputControlComponent,
        CheckboxControlComponent,
        RadioControlComponent,
        SelectControlComponent,
        ToggleControlComponent,
        SaveButtonComponent,
        CloseButtonComponent,
        ResetButtonComponent,
        TextareaControlComponent], imports: [CommonModule, ReactiveFormsModule, FormsModule], exports: [DynamicFormComponent, BaseControlComponent] });
NgxFormulusModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: NgxFormulusModule, imports: [[CommonModule, ReactiveFormsModule, FormsModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.0", ngImport: i0, type: NgxFormulusModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DynamicFormComponent,
                        BaseControlComponent,
                        DynamicControlDirective,
                        FormControlDirective,
                        InputControlComponent,
                        CheckboxControlComponent,
                        RadioControlComponent,
                        SelectControlComponent,
                        ToggleControlComponent,
                        SaveButtonComponent,
                        CloseButtonComponent,
                        ResetButtonComponent,
                        TextareaControlComponent,
                    ],
                    imports: [CommonModule, ReactiveFormsModule, FormsModule],
                    exports: [DynamicFormComponent, BaseControlComponent],
                }]
        }] });

class DynamicForm {
    constructor(config) {
        this.controls = [];
        this.overrides = [];
        this.formGroup = new FormGroup({});
        this.config = {};
        this.actions = {};
        // Event handling
        this.onSaveSubject = new Subject();
        this.onCloseSubject = new Subject();
        this.onResetSubject = new Subject();
        this.onChangeSubject = new Subject();
        this.onReloadSubject = new Subject();
        this.formGroup = config.formGroup || new FormGroup({});
        this.overrides = config.overrides || [];
        this.actions = config.actions || {};
        this.config = {
            overridesOnly: config.config?.overridesOnly || false,
        };
        this.mapControls();
        this.initForm();
    }
    /**
     * Get FormGroup
     */
    get FormGroup() {
        return this.formGroup;
    }
    /**
     * Get controls
     */
    get Controls() {
        return this.controls || [];
    }
    /**
     * Get action options
     */
    get Actions() {
        return this.actions;
    }
    /**
     * Get observable for save event
     * @returns Observable
     */
    get onSave() {
        return this.onSaveSubject.asObservable();
    }
    /**
     * Get observable for close event
     * @returns Observable
     */
    get onClose() {
        return this.onCloseSubject.asObservable();
    }
    /**
     * Get observable for reset event
     * @returns Observable
     */
    get onReset() {
        return this.onResetSubject.asObservable();
    }
    /**
     * Get observable for change event
     * @returns Observable
     */
    get onChange() {
        return this.onChangeSubject.asObservable();
    }
    /**
     * Get observable for form reload event
     * @returns Observable
     */
    get onReload() {
        return this.onReloadSubject.asObservable();
    }
    /**
     * Init form
     */
    initForm() {
        this.formChange = this.formGroup.valueChanges.pipe(tap(() => {
            this.onChangeSubject.next();
        }));
    }
    /**
     * Reload form
     */
    reloadForm(_formGroup, _overrides) {
        if (_formGroup) {
            this.formGroup = _formGroup;
        }
        if (_overrides) {
            this.overrides = _overrides;
        }
        this.mapControls();
        this.initForm();
        this.onReloadSubject.next();
    }
    /**
     * Trigger dynamicForm save event
     *
     */
    save() {
        this.onSaveSubject.next();
    }
    /**
     * Trigger dynamicForm close event
     */
    close() {
        this.onCloseSubject.next();
    }
    /**
     * Trigger dynamicForm reset event
     */
    reset() {
        this.onResetSubject.next();
    }
    /**
     * Clean form / reset
     */
    cleanForm() {
        this.formGroup.reset();
    }
    /**
     * Reload labels
     */
    reloadLabels() {
        // TODO: Implement dynamic reload for labels or accept observable as label
    }
    /**
     * Collect all errors from form controls
     * @returns string[]
     */
    collectErrors() {
        const errors = [];
        this.controls.forEach((control) => {
            if (control.formControl.errors) {
                const error = Object.keys(control.formControl.errors).map((key) => key.toUpperCase());
                errors.push(`${control.label} ${error.join(', ')}`);
            }
        });
        return errors;
    }
    /**
     * Map controls with overrides
     */
    mapControls() {
        const tempControls = [];
        const formControls = this.formGroup.controls;
        for (const formControlName in formControls) {
            const formControl = formControls[formControlName];
            const newControl = {
                formControl,
                formControlName,
                fullWidth: false,
                disabled: false,
                hidden: false,
                data: [],
            };
            const controlOverride = this.overrides.find((x) => x.formControlName === formControlName);
            // Overrides only
            if (this.config.overridesOnly && !controlOverride) {
                continue;
            }
            if (controlOverride) {
                newControl.label = controlOverride.label || formControlName;
                newControl.type = controlOverride.type || ControlType.Input;
                newControl.fullWidth = controlOverride.fullWidth || false;
                newControl.disabled = controlOverride.disabled || false;
                newControl.hidden = controlOverride.hidden || false;
                newControl.data = controlOverride.data || [];
                if (controlOverride.disabled) {
                    newControl.formControl.disable();
                }
            }
            else {
                newControl.label = formControlName;
                newControl.type = ControlType.Input;
            }
            tempControls.push(newControl);
        }
        this.controls = tempControls;
    }
}

var FormStyle;
(function (FormStyle) {
    FormStyle[FormStyle["NgBootstrap"] = 0] = "NgBootstrap";
    FormStyle[FormStyle["Nebular"] = 1] = "Nebular";
    FormStyle[FormStyle["Material"] = 2] = "Material";
})(FormStyle || (FormStyle = {}));

/*
 * Public API Surface of ngx-formulus
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BaseControlComponent, CheckboxControlComponent, CloseButtonComponent, ControlType, DynamicControlDirective, DynamicForm, DynamicFormComponent, FormControlDirective, FormStyle, InputControlComponent, NgxFormulusModule, RadioControlComponent, ResetButtonComponent, SaveButtonComponent, SelectControlComponent, TemplateService, TextareaControlComponent, ToggleControlComponent };
//# sourceMappingURL=ngx-formulus.mjs.map
