import type { Component } from '@angular/core';
import { ControlType } from '../../enums/control-type';
import type { NgxFormulusConfig } from '../../interfaces/ngx-formulus-config';
import * as i0 from "@angular/core";
export declare class TemplateService {
    private _config;
    private templates;
    readonly config: NgxFormulusConfig;
    constructor(_config: NgxFormulusConfig);
    /**
     * Get component by ControlType
     * @param controlType
     * @returns Component
     */
    getComponent(controlType: ControlType): Component;
    /**
     * Inject component for specific template
     * @param template
     * @param controlType
     */
    setTemplate(template: Component, controlType: ControlType): void;
    /**
     * Get all registered templates
     */
    get RegisteredTemplates(): {
        [id: string]: Component;
    };
    /**
     * Set all default templates for each component
     */
    private setDefaultTemplates;
    /**
     * Map all templates
     */
    private mapTemplates;
    /**
     * Get component by ControlType
     * @param type
     * @returns Component
     */
    private getComponentByType;
    static ɵfac: i0.ɵɵFactoryDeclaration<TemplateService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TemplateService>;
}
